function [x, U, D, g] = PCA(images, d)
%calculate the principal components of 'images', using 'd' dimensions

%size of training set
k = 300;

xi = zeros(16800, k);

% calculate mean image and covariance matrix
for i = 1:k
    xi(:,i) = reshape(images{i}.img, [], 1);
end

%mean column vector
x = (1/k) * sum(xi, 2);

%subtract mean
xi = xi - repmat(x, 1, k);

%Covariance matrix
C = (1/k-1) * (xi' * xi);

%Eigenvectors (E) & Eigenvalues (D)
[E, D] = eigs(C,d);

%Principal components
U = (E'*xi')';

%Make a reduced representation of the training set images
g = U'*xi;

whos

